###############################################################################
# YaBB2Backup.pl                                                              #
###############################################################################
# YaBB2 Backup                                                                #
# Allows the admin to backup forum data into a single file.                   #
# Version:        Beta 3.1 (YaBB 2.0/2.1)                                     #
# Released:       February 25th, 2005                                         #
# =========================================================================== #
# Written by AK108 for the YaBB community                                     #
###############################################################################
# Backup Admin area. Does all of the work.                                    # 
###############################################################################

if($action eq 'detailedversion') { return 1; }

# Add in support for Archive::Tar in the Modules directory and binaries in different places
push(@INC, './Modules/Archive/');
@ENVpaths = split(/\:/, $ENV{'PATH'});

# Add MIME::Lite to the path
push(@INC, './Modules/MIME/');

LoadLanguage('YaBB2Backup');

if(-e "$vardir/YaBB2Backup.txt") {require "$vardir/YaBB2Backup.txt"; $backupsettingsloaded = 1;}

$curtime = CORE::time; # None of that Time::HiRes stuff

sub backupsettings {
	my($module, $tarcompress, $command, $tarcompress2, $allchecked, $item, %pathchecklist, %methodchecklist, $presetjavascriptcode, $file, @backups);
	if(scalar @paths == 8) {$allchecked = 'checked="checked" ';}

	# Yes, my checklists are really hashes. Oh well.
	foreach $item (@paths) {$pathchecklist{$item} = 'checked="checked" ';}
	$methodchecklist{$backupmethod} = 'checked="checked" ';
	$methodchecklist{$compressmethod} = 'checked="checked" ';

	# domodulecheck if we have a checked value
	$presetjavascriptcode = qq~	domodulecheck("$backupmethod", 'init');~;
	
	# Javascript to make the behavior of the form buttons work better
	$yymain .= qq~
 <script type="text/javascript">
 <!--
	function checkYaBB () {
		// See if the check all box should be checked or unchecked.
		// It should be checked only if all the other boxes are checked.
		if(document.backupsettings.YaBB_Boards.checked && document.backupsettings.YaBB_Messages.checked && document.backupsettings.YaBB_Members.checked && document.backupsettings.YaBB_Templates.checked && document.backupsettings.YaBB_Languages.checked && document.backupsettings.YaBB_Variables.checked && document.backupsettings.YaBB_Admin_Sources.checked && document.backupsettings.YaBB_yabbfiles.checked) {
			document.backupsettings.YaBB_ALL.checked = 1;
		}
		else {
			document.backupsettings.YaBB_ALL.checked = 0;
		}
	}
	function masscheckYaBB (toggleboxstate) {
		if(!toggleboxstate) { // Uncheck all
			checkstate = 0;
		}
		else if(toggleboxstate) { // Check all
			checkstate = 1;
		}
		document.backupsettings.YaBB_Boards.checked = checkstate;
		document.backupsettings.YaBB_Messages.checked = checkstate;
		document.backupsettings.YaBB_Members.checked = checkstate;
		document.backupsettings.YaBB_Templates.checked = checkstate;
		document.backupsettings.YaBB_Languages.checked = checkstate;
		document.backupsettings.YaBB_Variables.checked = checkstate;
		document.backupsettings.YaBB_Admin_Sources.checked = checkstate;
		document.backupsettings.YaBB_yabbfiles.checked = checkstate;
	}
	function domodulecheck (module, initstate) {
		if(module == "Archive::Tar") {
			for(i = 0; document.getElementsByName("tarmodulecompress")[i]; i++) {
				document.getElementsByName("tarmodulecompress")[i].disabled = false;
			}
			if(!initstate) {
				document.getElementsByName("tarmodulecompress")[0].checked = true;
			}
		}
		else {
			for(i = 0; document.getElementsByName("tarmodulecompress")[i]; i++) {
				document.getElementsByName("tarmodulecompress")[i].disabled = true;
			}
		}

		if(module == "/bin/tar") {
			for(i = 0; document.getElementsByName("bintarcompress")[i]; i++) {
				document.getElementsByName("bintarcompress")[i].disabled = false;
			}
			if(!initstate) {
				document.getElementsByName("bintarcompress")[0].checked = true;
			}
		}
		else {
			for(i = 0; document.getElementsByName("bintarcompress")[i]; i++) {
				document.getElementsByName("bintarcompress")[i].disabled = true;
			}
		}
	}
 -->
 </script>
 <form action="$adminurl?action=backupsettings2" method="post" name="backupsettings">
 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       <td align="left" class="titlebg">
         <img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$backup_txt{1}</b>
       </td>
     </tr>~;
	if(!$backupsettingsloaded) {
		$yymain .= qq~
     <tr valign="middle">
       <td align="left" class="catbg">
         <b>$backup_txt{2}</b>
       </td>
     </tr>
     <tr valign="middle">
       <td align="left">
         <!-- Empty td for a spacer -->
       </td>
     </tr>~;
	}
	$yymain .= qq~
     <tr valign="middle">
       <td align="left" class="windowbg">
         $backup_txt{3}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="catbg">
         <b>$backup_txt{4}</b> (<input type="checkbox" name="YaBB_ALL" value="1" onclick="masscheckYaBB(this.checked)" $allchecked/>$backup_txt{5})
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg">
         $backup_txt{6}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="checkbox" onclick="checkYaBB()" name="YaBB_Boards" value="1" $pathchecklist{'Boards'}/> Boards/ $backup_txt{7}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="checkbox" onclick="checkYaBB()" name="YaBB_Messages" value="1" $pathchecklist{'Messages'}/> Messages/ $backup_txt{8}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="checkbox" onclick="checkYaBB()" name="YaBB_Members" value="1" $pathchecklist{'Members'}/> Members/ $backup_txt{9}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="checkbox" onclick="checkYaBB()" name="YaBB_Templates" value="1" $pathchecklist{'Templates'}/> Templates/ $backup_txt{10}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="checkbox" onclick="checkYaBB()" name="YaBB_Languages" value="1" $pathchecklist{'Languages'}/> Languages/ $backup_txt{11}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="checkbox" onclick="checkYaBB()" name="YaBB_Variables" value="1" $pathchecklist{'Variables'}/> Variables/ $backup_txt{12}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="checkbox" onclick="checkYaBB()" name="YaBB_Admin_Sources" value="1" $pathchecklist{'Admin_Sources'}/> Admin/ $backup_txt{'and'} Sources/ $backup_txt{13}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="checkbox" onclick="checkYaBB()" name="YaBB_yabbfiles" value="1" $pathchecklist{'yabbfiles'}/> yabbfiles $backup_txt{14}
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="catbg">
         <b>$backup_txt{15}</b>
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg">
         <b>$backup_txt{16}</b>
       </td>
     </tr>~;

	# Make a list of modules that we can use with Tar::Archive
	$tarcompress = qq~
     <tr valign="middle">
       <td align="left" class="windowbg">
         <input type="radio" name="tarmodulecompress" value="none" $methodchecklist{'none'}/>$backup_txt{17}
       </td>
     </tr>~;
	foreach $module qw(Compress::Zlib Compress::Bzip2) {
		eval "use $module ();";
		if(!$@) {
			$tarcompress .= qq~
     <tr valign="middle">
       <td align="left" class="windowbg">
         <input type="radio" name="tarmodulecompress" value="$module" $methodchecklist{$module}/>$module $backup_txt{18}
       </td>
     </tr>~;
		}
	}
	# Display the modules that we can use
	foreach $module qw(Archive::Tar Archive::Zip) {
		eval "use $module ();";
		if(!$@) {
			$yymain .= qq~
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="radio" name="backupmethod" value="$module" onclick="domodulecheck('$module')" $methodchecklist{$module}/>$module
       </td>
     </tr>~;
			if($module eq 'Archive::Tar') {$yymain .= $tarcompress}
		}
	}

	# Make a list of compression commands we can use with /bin/tar
	$tarcompress2 = qq~
     <tr valign="middle">
       <td align="left" class="windowbg">
         <input type="radio" name="bintarcompress" value="none" $methodchecklist{'none'}/>$backup_txt{17}
       </td>
     </tr>~;
	foreach $command qw(/bin/bzip2 /bin/gzip) {
		my $newcommand = &CheckPath($command);
		if($newcommand) {
			$tarcompress2 .= qq~
     <tr valign="middle">
       <td align="left" class="windowbg">
         <input type="radio" name="bintarcompress" value="$command" $methodchecklist{$command}/>$newcommand $backup_txt{18}
       </td>
     </tr>~;
		}
	}
	# Display the commands we can use for compression
	# Non-translated here, as I doubt there are words to describe "tar" in another language
	my $newcommand = &CheckPath('/bin/tar');
	if($newcommand) {
		$yymain .= qq~
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="radio" name="backupmethod" value="/bin/tar" onclick="domodulecheck('/bin/tar')" $methodchecklist{'/bin/tar'}/>Tar ($newcommand)
       </td>
     </tr>$tarcompress2~;
	}
	my $newcommand = &CheckPath('/usr/bin/zip');
	if($newcommand) {
		$yymain .= qq~
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="radio" name="backupmethod" value="/usr/bin/zip" onclick="domodulecheck('/usr/bin/zip')" $methodchecklist{'/usr/bin/zip'}/>Zip ($newcommand)
       </td>
     </tr>~;
	}

	# Last but not least, the submit button and the $backupdir path.
	$backupdir ||= './Backups';
	$yymain .= qq~
     <tr valign="middle">
       <td align="left" class="catbg">
         <b>$backup_txt{19}</b>
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
         <input type="text" name="backupdir" value="$backupdir" />
       </td>
     </tr>
     <tr valign="middle">
       <td align="center" class="catbg">
         <input type="submit" name="submit" value="$backup_txt{20}" />
       </td>
     </tr>
   </table>
 </div>
 </form>
 <script type="text/javascript">
 <!--
$presetjavascriptcode
 //-->
 </script>~;

	# Here we go again with another table. Here's the backup button area
	if($backupsettingsloaded) {
		$yymain .= qq~
 <br />
 <form action="$adminurl?action=runbackup" method="post" name="runbackup">
 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       <td align="left" class="titlebg" colspan="2">
         <img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$backup_txt{21}</b>
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2" colspan="2">
         $backup_txt{22} $backupdir $backup_txt{23}
         <br />
         <br />$backup_txt{24}
       </td>
     </tr>
     <tr valign="top">
       <td align="left" class="windowbg2" width="50%">
         $admin_txt{'348Text'}
       </td>
       <td align="center" class="windowbg2" width="50%">
         <textarea cols="30" rows="5" name="maintenancetext" style="width: 98%;"></textarea>
       </td>
     </tr>
     <tr valign="middle">
       <td align="center" class="catbg" colspan="2">
         <input type="submit" name="submit" value="$backup_txt{25}" />
       </td>
     </tr>
   </table>
 </div>
 </form>~;
	}

	# Yet another table to allow the user to download the backups.
	if($backupsettingsloaded) {
		$yymain .= qq~
 <br />
 <form action="$adminurl?action=runbackup" method="post" name="runbackup">
 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       <td align="left" class="titlebg" colspan="2">
         <img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$backup_txt{35}</b>
       </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2" colspan="2">
         $backup_txt{36} (<tt>$backupdir</tt>)
         <br />
         <br />$backup_txt{37}
         <ul>
~;

		# Look for the files.
		opendir(BACKUPDIR, $backupdir);
		@backups = readdir(BACKUPDIR);
		closedir(BACKUPDIR);

		foreach $file (sort(@backups)) {
			if($file !~ /\Abackup/) {next;}
			$file =~ /backup\.(\d+)\./;
			my $filesize = -s "$backupdir/$file";
			$filesize = int($filesize / 1024); # Measure it in kilobytes
			if($filesize > 1024 * 4) {$filesize = int($filesize / 1024) . ' MB';} # Measure it in megabytes
			else {$filesize .= ' KB';} # Label it

			$filelist .= qq~           <li><a href="$adminurl?action=downloadbackup;backupid=$file">~ . &timeformat($1) . qq~</a>, $filesize (<a href="$adminurl?action=emailbackup;backupid=$file">$backup_txt{52}</a>) (<a href="$adminurl?action=deletebackup;backupid=$file">$backup_txt{53}</a>)</li>\n~;
		}

		$filelist ||= qq~           <li><i>$backup_txt{38}</i></li>~;

		$yymain .= qq~$filelist
         </ul>
       </td>
     </tr>
   </table>
 </div>
 </form>~;
	}

	$action_area = 'backupsettings';
	&AdminTemplate;
	exit;
}

sub backupsettings2 {
	my($path, $output, $backupmethod);
	$backupmethod = $FORM{'backupmethod'};
	$compressmethod = $FORM{'bintarcompress'} || $FORM{'tarmodulecompress'} || 'none';

	# Write out the data. Be careful with the quote types, as they must be right to make it work.

	# First, we'll handle the paths.
	if($FORM{'YaBB_ALL'}) { # handle the magic select all checkbox so Javascript can be disabled and it still work
		$output = q~@paths = qw(Boards Messages Members Templates Languages Variables Admin_Sources yabbfiles);~;
	}
	else {
		$output = q~@paths = qw(~;
		foreach $path qw(Boards Messages Members Templates Languages Variables Admin_Sources yabbfiles) {
			if($FORM{'YaBB_'.$path}) {$output .= qq~$path ~;}
		}
		$output =~ s/ \Z//;
		$output .= q~);~;
	}

	# Check the backup method
	if($backupmethod =~ /\:\:/) { # It's a module, test-require it
		eval "use $backupmethod ();";
		if($@) {&admin_fatal_error("$backup_txt{39} $backupmethod $backup_txt{41}");}
	}
	else {
		$backupmethod = &CheckPath($backupmethod);
		if(!-e $backupmethod) {&admin_fatal_error("$backup_txt{40} $backupmethod $backup_txt{41}");}
	}
	$output .= qq~

\$backupmethod = '$backupmethod';~;

	# If we're using /bin/tar, check for the compression method.
	if($backupmethod eq '/bin/tar' && $compressmethod ne 'none') {
		$compressmethod = &CheckPath($compressmethod);
		if(!-e $compressmethod) {&admin_fatal_error("$backup_txt{40} $compressmethod $backup_txt{41}");}
	}
	# If we're using Archive::Tar, check for the compression method.
	if($backupmethod eq 'Archive::Tar' && $compressmethod ne 'none') {
		eval "use $compressmethod ();";
		if($@) {&admin_fatal_error("$backup_txt{39} $compressmethod $backup_txt{41}");}
	}
	if($backupmethod eq 'Archive::Tar' || $backupmethod eq '/bin/tar') {
		$output .= qq~
\$compressmethod = '$compressmethod';~;
	}

	# Set $backupdir
	if(!-w $FORM{'backupdir'}) {
		&admin_fatal_error("$backup_txt{42} \$backupdir \'$FORM{'backupdir'}\'. $backup_txt{43}");
	}
	$output .= qq~

\$backupdir = \'$FORM{'backupdir'}\';~;

	# Finish out the file
	$output .= q~

1;~;

	fopen(BACKUPSETTINGS, ">$vardir/YaBB2Backup.txt") || &admin_fatal_error("$backup_txt{42} $vardir/YaBB2Backup.txt: $!");
	print BACKUPSETTINGS $output;
	fclose(BACKUPSETTINGS);

	$yySetLocation = qq~$adminurl?action=backupsettings~;
	&redirectexit;
}

sub runbackup {
	# This routine actually does the backup.
	my(@settings, $prevmainsetting, $prevmaintext, $newmaintext, %pathconvert, $subpath, $backuptime);
	$prevmainsetting = $maintenance;
	$prevmaintext = $maintenancetext;
	$newmaintext = $FORM{'maintenancetext'} || $maintenancetext || $backup_txt{26};

	# Let's load Time::HiRes using eval if possible, cause it's nice.
	eval 'use Time::HiRes qw(time);';
	$backuptime = time;

	# Verify that our method is possible, and load it if it's a module
	&BackupMethodInit;

	# First things first: set the forum to maintenance mode.
	fopen(SETTINGS, "$vardir/Settings.pl");
	@settings = <SETTINGS>;
	fclose(SETTINGS);

	for($i = 0; $i < scalar @settings; $i++) {
		if($settings[$i] =~ /\$maintenance =/) {
			$settings[$i] =~ s/\$maintenance = \d;/\$maintenance = 1;/;
		}
		if($settings[$i] =~ /\$maintenancetext = /) {
			$settings[$i] =~ s/\$maintenancetext = "$maintenancetext";/\$maintenancetext = "$newmaintext";/;
		}
	}

	fopen(SETTINGS, ">$vardir/Settings.pl");
	print SETTINGS @settings;
	fclose(SETTINGS);

	# Handle the conversion of the informal paths stored in the settings file to the real ones
	# I'll build a hash to quickly match them.
	# A pipe separates them in the case of needing multiple real paths to handle one informal path
	%pathconvert = (
	'Members', $memberdir,
	'Admin_Sources', join('|', ($admindir, $sourcedir, './Modules')) . "|!$boarddir",
	'Boards', $boardsdir,
	'Messages', $datadir,
	'Variables', $vardir,
	'Templates', join('|', ($templatesdir, $forumstylesdir, $adminstylesdir)),
	'Languages', $langdir,
	'Help', $helpdir,
	'yabbfiles', $htmldir
	);

	# To keep this simple, I'll just point to a generic subroutine that takes care of handling the differences in backup methods.
	foreach $path (@paths) {
		$yymain .= qq~$backup_txt{27} $path<br />\n~;
		foreach $subpath (split(/\|/, $pathconvert{$path})) {
			&BackupDirectory($subpath);
		}
	}

	# Undo maintenance mode.
	fopen(SETTINGS, "$vardir/Settings.pl");
	@settings = <SETTINGS>;
	fclose(SETTINGS);

	for($i = 0; $i < scalar @settings; $i++) {
		if($settings[$i] =~ /\$maintenance =/) {
			$settings[$i] =~ s/\$maintenance = \d;/\$maintenance = $prevmainsetting;/;
		}
		if($settings[$i] =~ /\$maintenancetext = /) {
			$settings[$i] =~ s/\$maintenancetext = "$newmaintext";/\$maintenancetext = "$prevmaintext";/;
		}
	}

	fopen(SETTINGS, ">$vardir/Settings.pl");
	print SETTINGS @settings;
	fclose(SETTINGS);

	# Last, we'll finalize the archive if needed. This can safely be done with the forum out of maintenance mode.
	# This involves joining the archives together if needed. If it's a tar, we compress them, if requested.
	&BackupMethodFinalize;

	# Display the amount of time it took to be nice ;)
	$backuptime = time - $backuptime;
	$backuptime =~ s~\.(\d{4}).*~\.$1~;
	$yymain .= qq~<br />
$backup_txt{33} $backuptime $backup_txt{34}<br />~;

	$action_area = 'backupsettings';
	&AdminTemplate;
}

sub BackupMethodInit {
	# Checks once more that we can use the command or module given. If we can, we load module(s) here.

	# Check module types and load them at runtime (not compilation)
	if($backupmethod eq 'Archive::Tar') {
		eval 'use Archive::Tar;'; # Everything is exported at once
		if($@) {&fatal_error("$backup_txt{28} Archive::Tar: $@");}
		if($compressmethod eq 'Compress::Zlib') { # Also using Zlib
			eval 'use Compress::Zlib;'; # Zlib exports everything at once
			if($@) {&fatal_error("$backup_txt{28} Compres::Zlib: $@");}
		}
		elsif($compressmethod eq 'Compress::Bzip2') {
			eval 'use Compress::Bzip2 qw(:utilities);'; # Finally, something I can export just some code with
			if($@) {&fatal_error("$backup_txt{28} Compress::Bzip2: $@");}
		}
		else {$compressmethod = 'none';}
		$tarball = Archive::Tar->new;
	}
	elsif($backupmethod eq 'Archive::Zip') {
		eval 'use Archive::Zip;'; # Everything's exported by default here too
		if($@) {&fatal_error("$backup_txt{28} Archive::Zip: $@");}
		$zipfile = Archive::Zip->new;
	}
	else {
		unless(&CheckPath($backupmethod)) {&admin_fatal_error("$backup_txt{29} $backupmethod.");}
		if($compressmethod && $compressmethod ne 'none') {
			unless(&CheckPath($compressmethod)) {&admin_fatal_error("$backup_txt{30} $compressmethod.");}		
		}
	}
}

sub BackupDirectory {
	# Handles all the fun of directly archiving a directory.
	my($dir, $recursemode, $recurseoptions);
	$dir = $_[0];
	if($dir =~ /\A\!/) {$recursemode = 0;}
	else {$recursemode = 1;}
	$dir =~ s/\A\!//;

	if($backupmethod eq '/bin/tar') {
		if(!$recursemode) {$dir .= '/*.*';}
		else {$recurseoptions = '--recurse ';}
		ak_system("tar -r -f $backupdir/backup.$curtime.tar $dir") || &fatal_error("$backup_txt{31} tar: $!. $backup_txt{32} " . ($? >> 8));
	}
	elsif($backupmethod eq '/usr/bin/zip') {
		if(!$recursemode) {$dir .= '/*.*';}
		else {$recurseoptions = '-r ';}
		ak_system("zip -g $recurseoptions $backupdir/backup.$curtime.zip $dir") || &fatal_error("$backup_txt{31} zip: $!. $backup_txt{32} " . ($? >> 8));
	}
	elsif($backupmethod eq 'Archive::Tar') {
		push(@dircontents, &RecurseDirectory($dir, $recursemode));
	}
	elsif($backupmethod eq 'Archive::Zip') {
		push(@dircontents, &RecurseDirectory($dir, $recursemode));
	}
}

sub RecurseDirectory {
	# Simple subroutine to run through every entry in a directory and return a giant list of the files/subdirs.
	my($dir, $recursemode, $item, @dirlist, @newcontents);
	$dir = $_[0];
	$recursemode = $_[1];

	opendir(RECURSEDIR, $dir);
	@dirlist = readdir(RECURSEDIR);
	closedir(RECURSEDIR);

	foreach $item (@dirlist) {
		if(-d "$dir/$item" && $recursemode && $item ne '.' && $item ne '..') {push(@newcontents, &RecurseDirectory("$dir/$item", $recursemode));}
		elsif(-f "$dir/$item") {push(@newcontents, "$dir/$item");}
	}
	return @newcontents;
}

sub BackupMethodFinalize {
	# Compresses the tar
	if($backupmethod eq '/bin/tar') {
		if($compressmethod eq '/bin/bzip2') {
			ak_system("bzip2 -z $backupdir/backup.$curtime.tar") || &fatal_error("$backup_txt{31} bzip2: $!. $backup_txt{32} " . ($? >> 8));
		}
		elsif($compressmethod eq '/bin/gzip') {
			ak_system("gzip $backupdir/backup.$curtime.tar") || &fatal_error("$backup_txt{31} gzip: $!. $backup_txt{32} " . ($? >> 8));
		}
	}
	elsif($backupmethod eq 'Archive::Tar') {
		$tarball->add_files(@dircontents);
		if($compressmethod eq 'none') {$tarball->write("$backupdir/backup.$curtime.tar", 0);}
		elsif($compressmethod eq 'Compress::Zlib') { # Gzip as a module
			my($gzip) = gzopen("$backupdir/backup.$curtime.tar.gz", 'wb');
			$gzip->gzwrite($tarball->write);
			$gzip->gzclose();
		}
		elsif($compressmethod eq 'Compress::Bzip2') { # Bzip2 as a module
			my($bzip2) = bzopen("$backupdir/backup.$curtime.tar.bz2", 'wb');
			$bzip2->bzwrite($tarball->write);
			$bzip2->bzclose();
		}
	}
	elsif($backupmethod eq 'Archive::Zip') {
		my($file);
		foreach $file (@dircontents) {
			$zipfile->addFile($file);
		}
		$zipfile->writeToFileNamed("$backupdir/backup.$curtime.zip");
	}
}

sub ak_system { # Returns a success code. The system's code returned is $? >> 8
	CORE::system(@_);
	if ($? == -1) {
		return ''; # Failed to execute; return a null string.
	}
	elsif ($? & 127) {
		return 0; # Died, return 0.
	}
	else {
		return 1; # Success; return 1.
	}
}

sub CheckPath {
	my($path, $file);
	$file = $_[0];

	if(-e $file) {return $file;}

	$file =~ s~\A.*\/~~;

	foreach $path (@ENVpaths) {
		$path =~ s~\/\Z~~;
		if(-e "$path/$file") {return "$path/$file";}
	}
	return 0;
}

# Thanks to BBQ at PerlMonks for the basis of this routine: http://www.perlmonks.org/?node_id=9277
sub downloadbackup {
	chdir($backupdir) || &admin_fatal_error("$backup_txt{44} $backupdir: $!");
	my $filename = $INFO{'backupid'};
	if($filename !~ /\Abackup/ || $filename !~ /\d{9,10}/) {&admin_fatal_error($backup_txt{'45'});}
	my $filesize = -s $filename;

	# print full header
	print "Content-disposition: inline; filename=$filename\n";
	print "Content-Length: $filesize\n";
	print "Content-Type: application/octet-stream\n\n";

	# open in binmode
	fopen(READ, $filename) || &admin_fatal_error("$backup_txt{46} $filename: $!");
	binmode READ;

	# stream it out
	binmode STDOUT;
	while (<READ>) {print;}
	fclose(READ);
}

sub deletebackup {
	my $filename = $INFO{'backupid'};
	if($filename !~ /\Abackup/ || $filename !~ /\d{9,10}/) {&admin_fatal_error($backup_txt{'45'});}

	$yymain = qq~
$backup_txt{47} $filename? $backup_txt{48}
<br />
<br /><a href="$adminurl?action=deletebackup2;backupid=$filename">$backup_txt{49}</a> | <a href="$adminurl?action=backupsettings">$backup_txt{50}</a>
~;

	&AdminTemplate;
}

sub deletebackup2 {
	my $filename = $INFO{'backupid'};
	if($filename !~ /\Abackup/ || $filename !~ /\d{9,10}/) {&admin_fatal_error($backup_txt{'45'});}

	# Just remove it!
	unlink("$backupdir/$filename") || &admin_fatal_error("$backup_txt{51} $backupdir/$filename: $!");

	$yySetLocation = "$adminurl?action=backupsettings";
	&redirectexit();
}

sub emailbackup {
	# Unfourtantly, we can't use &sendmail() for this.
	# So, we'll load MIME::Lite and try that, as it should work.
	# If not, we'll email out a download link.
	my($mainmessage, $filename);

	$filename = $INFO{'backupid'};
	if($filename !~ /\Abackup/ || $filename !~ /\d{9,10}/) {&admin_fatal_error($backup_txt{'45'});}

	# Try to safely load MIME::Lite
	eval 'use MIME::Lite;';
	if(!$@) { # We can use MIME::Lite.
		&FromHTML($mbname);
		&FromHTML(${$uid.$username}{'email'});
		$mainmessage = $backup_txt{'mailmessage1'};
		$mainmessage =~ s~USERNAME~${$uid.$username}{'realname'}~g;
		$mainmessage =~ s~LINK~$adminurl?action=downloadbackup;backup=$filename~g;
		$mainmessage =~ s~FILENAME~$filename~g;

		$msg = MIME::Lite->new(
                 	To      => ${$uid.$username}{'email'},
			From    => $backup_txt{'mailfrom'},
			Subject => $backup_txt{'mailsubject'},
			Type    => 'multipart/mixed'
			);
		$msg->attach(
			Type => 'TEXT',
			Data => $mainmessage
		);
		$msg->attach(
			Type     => 'AUTO', # Let it be auto-detected.
			Filename => $filename,
			Path     => "$backupdir/$filename",
		);
		$msg->send();
	}
	else {
		$mainmessage = $backup_txt{'mailmessage1'};
		$mainmessage =~ s~USERNAME~${$uid.$username}{'realname'}~g;
		$mainmessage =~ s~LINK~$adminurl?action=downloadbackup;backup=$filename~g;
		$mainmessage =~ s~FILENAME~$filename~g;
		&sendmail(${$uid.$username}{'email'}, $backup_txt{'mailsubject'}, $mainmessage, $backup_txt{'mailfrom'});
	}

	$yySetLocation = "$adminurl?action=backupsettings";
	&redirectexit();
}

1;
